/*
 * 优惠券领取记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class CouponsForUserController : BaseController
    {
        public CouponsForUserController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 优惠券领取记录列表

        /// <summary>
        /// 根据条件查询优惠券领取记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(CouponsForUser data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            string Condition = "";
            Condition += "IsUse:\"" + data.IsUse + "\",";
            Condition += "IsLock:\"" + data.IsLock + "\",";

            if (!string.IsNullOrEmpty(Condition))
            {
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询优惠券领取记录列表

        /// <summary>
        /// 优惠券领取记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(CouponsForUser data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("IsUse", "1"); //是否使用
            Fields.Add("IsLock", "1"); //是否锁定

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("CouponsForUser", Fields, "Id desc", "False", page, limit);
            
            return Json(obj);
        }

        #endregion

        #region 增加优惠券领取记录

        /// <summary>
        /// 增加或修改优惠券领取记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加优惠券领取记录

        /// <summary>
        /// 增加或修改优惠券领取记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(CouponsForUser data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("IsUse", data.IsUse); //是否使用
            Fields.Add("IsLock", data.IsLock); //是否锁定
            Fields.Add("UseDate", data.UseDate); //使用时间

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("CouponsForUser", Fields, 0);
            AddSysLog(data.Id.ToString(), "CouponsForUser", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改优惠券领取记录

        /// <summary>
        /// 增加或修改优惠券领取记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            CouponsForUser editData = db.CouponsForUser.FirstOrDefault(m => m.Id == Id) ?? new CouponsForUser();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改优惠券领取记录

        /// <summary>
        /// 增加或修改优惠券领取记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(CouponsForUser data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("IsUse", data.IsUse); //是否使用
            Fields.Add("IsLock", data.IsLock); //是否锁定
            Fields.Add("UseDate", data.UseDate); //使用时间

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("CouponsForUser", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "CouponsForUser", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除优惠券领取记录信息

        /// <summary>
        /// 删除优惠券领取记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "CouponsForUser", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Delete("CouponsForUser", id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "CouponsForUser", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("CouponsForUser", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "CouponsForUser", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("CouponsForUser", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("CouponsForUser", Sort, Id);

            AddSysLog(Id.ToString(), "CouponsForUser", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];
                ulong IsUse = ulong.Parse(dr["是否使用"].ToString());
                ulong IsLock = ulong.Parse(dr["是否锁定"].ToString());
                string UseDate = dr["使用时间"].ToString();

                db.CouponsForUser.Add(new CouponsForUser()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    IsUse = IsUse,   //是否使用
                    IsLock = IsLock,   //是否锁定
                    UseDate = DateTime.Parse(UseDate),   //使用时间

                });
                db.SaveChanges();
            }
            AddSysLog("0", "CouponsForUser", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(CouponsForUser data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("IsUse", "1"); //是否使用
            Fields.Add("IsLock", "1"); //是否锁定

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("CouponsForUser", Fields, "Id desc", "False", 1, 20000, "", "IsUse,IsLock,UseDate", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("IsUse", "是否使用");
            ReturnFields.Add("IsLock", "是否锁定");
            ReturnFields.Add("UseDate", "使用时间");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "CouponsForUser", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}